package com.kingdee.eas.custom.facade.plurality;

import javax.ejb.*;
import java.rmi.RemoteException;
import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;
import com.kingdee.eas.framework.Result;
import com.kingdee.eas.framework.LineResult;
import com.kingdee.eas.framework.exception.EASMultiException;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;

import com.kingdee.eas.common.EASBizException;
import java.lang.String;



public abstract class AbstractPluralitySubFacadeControllerBean extends AbstractBizControllerBean implements PluralitySubFacadeController
{
    protected AbstractPluralitySubFacadeControllerBean()
    {
    }

    protected BOSObjectType getBOSType()
    {
        return new BOSObjectType("A8411F30");
    }

    public void autoPluralitEnd(Context ctx, String personId, String curdate, int offset) throws BOSException, EASBizException
    {
        try {
            ServiceContext svcCtx = createServiceContext(new MetaDataPK("28044960-f04f-4523-ac82-3d53d3763e06"), new Object[]{ctx, personId, curdate, new Integer(offset)});
            invokeServiceBefore(svcCtx);
              if(!svcCtx.invokeBreak()) {
            _autoPluralitEnd(ctx, personId, curdate, offset);
            }
            invokeServiceAfter(svcCtx);
        } catch (BOSException ex) {
            throw ex;
        } catch (EASBizException ex0) {
            throw ex0;
        } finally {
            super.cleanUpServiceState();
        }
    }
    protected void _autoPluralitEnd(Context ctx, String personId, String curdate, int offset) throws BOSException, EASBizException
    {    	
        return;
    }

    public void resignCreateEnd(Context ctx, String personId, String endDate) throws BOSException, EASBizException
    {
        try {
            ServiceContext svcCtx = createServiceContext(new MetaDataPK("30847b82-b812-43d3-be17-fa9bfa469cf2"), new Object[]{ctx, personId, endDate});
            invokeServiceBefore(svcCtx);
              if(!svcCtx.invokeBreak()) {
            _resignCreateEnd(ctx, personId, endDate);
            }
            invokeServiceAfter(svcCtx);
        } catch (BOSException ex) {
            throw ex;
        } catch (EASBizException ex0) {
            throw ex0;
        } finally {
            super.cleanUpServiceState();
        }
    }
    protected void _resignCreateEnd(Context ctx, String personId, String endDate) throws BOSException, EASBizException
    {    	
        return;
    }

}